# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..12\n"; }
END {print "not ok 1\n" unless $loaded;}
use Awale::TextSearch;
$loaded = 1;
print "ok 1\n";
######################### End of black magic.

$^W=1;
use strict;

my $search=Awale::TextSearch->new("t/foo");

# stem search
my $IDs=$search->search("world", linear=>1);
print "not $! " unless 2==keys %$IDs;
print "ok 2\n";

# exact search
$IDs=$search->search("world", exact=>1, linear=>1);
print "not $! " unless 1==keys %$IDs;
print "ok 3\n";

# failed search
$IDs=$search->search("nada", linear=>1);
print "not $! " unless $IDs and 0==keys %$IDs;
print "ok 4\n";

$IDs=$search->search("luck", linear=>1);
print "not " unless 4==keys %$IDs;
print "ok 5\n";

$IDs=$search->search("luck", exact=>1, linear=>1);
print "not " unless 3==keys %$IDs;
print "ok 6\n";

my $rs=Awale::TextSearch::RS();
print "not " unless $rs and length($rs)==1;
print "ok 7\n";

$IDs=$search->search("acba", bm=>1);
# warn join ', ', keys %$IDs;
print "not " unless 0==keys %$IDs;
print "ok 8\n";

$IDs=$search->search("luck", bm=>1);
print "not " unless 4==keys %$IDs;
print "ok 9\n";



$IDs=$search->search("beat", bm=>1);
print "not " unless 0==keys %$IDs;
print "ok 10\n";

$IDs=$search->search("worldbeat", bm=>1);
print "not " unless 1==keys %$IDs;
print "ok 11\n";

$IDs=$search->search("luck", bm=>1, exact=>1);
print "not " unless 3==keys %$IDs;
print "ok 12\n";


