# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..9\n"; }
END {print "not ok 1\n" unless $loaded;}
use Awale::TextSearch;
$loaded = 1;
print "ok 1\n";
######################### End of black magic.

$^W=1;
use strict;

my $search=Awale::TextSearch->new("t/foo");

# stem search
my $IDs=$search->search("world", k=>1);
print "not " unless 2==keys %$IDs;
print "ok 2\n";

# exact search
$IDs=$search->search("warld", exact=>1, k=>1);
print "not " unless 1==keys %$IDs;
print "ok 3\n";

# fuzzy search
$IDs=$search->search("hella", k=>1);
print "not " unless 1==keys %$IDs;
print "ok 4\n";

# fuzzy search
$IDs=$search->search("halla", k=>1);
print "not " unless 0==keys %$IDs;
print "ok 5\n";


# fuzzy search
$IDs=$search->search("beat", k=>1);
print "not " unless 0==keys %$IDs;
print "ok 6\n";

#############
# bad searches

print STDERR "\rNext 3 tests should produce warning messages:\n";
$IDs=$search->search("beat"x10, k=>1);
print "not " unless 0==keys %$IDs;
print "ok 7\n";

print STDERR "\r";

$IDs=$search->search("worldbeat", k=>5);
print "not " unless 0==keys %$IDs;
print "ok 8\n";

print STDERR "\r";

$IDs=$search->search("worldbeat", k=>24);
print "not " unless 0==keys %$IDs;
print "ok 9\n";

